unit uMenu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnMenus, ToolWin, ActnMan, ActnCtrls, XPStyleActnCtrls,
  ActnList, XPMan, StdCtrls, ComCtrls, ExtCtrls, ImgList, uRechFile;

type
  TTestForm = class(TForm)
    ActionManager: TActionManager;
    ActionToolBar: TActionToolBar;
    ActionMainMenuBar: TActionMainMenuBar;
    Label1: TLabel;
    Bevel1: TBevel;
    LabelStatusFichier: TLabel;
    StatusBar: TStatusBar;
    ProgressBarRecurse: TProgressBar;
    ListBoxErreur: TListBox;
    Label4: TLabel;
    Bevel2: TBevel;
    LabelStatusFree: TLabel;
    ProgressBarCreateTemp: TProgressBar;
    Bevel3: TBevel;
    LabelStatusFree2: TLabel;
    ProgressBarVerifTemp: TProgressBar;
    ImageListVF: TImageList;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    ImageTest1: TImage;
    ImageTest2: TImage;
    LabelStatusSize: TLabel;
    ProgressBarFile: TProgressBar;
    procedure FormCreate(Sender: TObject);
    procedure Action2Execute(Sender: TObject);
    procedure Action1Execute(Sender: TObject);
    procedure Action3Execute(Sender: TObject);
  private
    procedure SetValidation(Etape: Integer; const Value: boolean);
  private
    { Dclarations prives }
    OldTemps: DWord;
    CumulTailleTest,
    CumulTaille: Int64;
    RechNbFich: TNombreFichier;

    procedure CalculVitesse(const NombreOctet: Int64);

    function TestFiles(const Dossier: string): boolean;
    function TestFile(const FileName: string): boolean;
    function RechercheFile(const Dossier: string): boolean;

    function CreateTempFile(const Lecteur: Char; const ListFichier: TStrings): boolean;
    function TestTempFile(const ListFichier: TStrings): boolean;

    procedure RAZ;
    property Validation[Etape: Integer]: boolean write SetValidation;
  public
    { Dclarations publiques }
    procedure VerificationEspaceLibre(const Lecteur: Char);
  end;

var
  TestForm: TTestForm;

implementation

{$R *.dfm}

uses FileTools, PaintUtils, Math, DisqueChoice, RepChoice;

resourcestring
  rsNoneOp         = 'Le test n''a pas encore t effectu';
  rsDossier        = 'Dossier : %s';
  rsTailleFichiers = 'Nombre d''octet lu : %s, Fichier courrant : %s';
  rsFileTemp       = 'Nom du fichier temporaire : %s';
  rsInitBufContent = 'Initialisation du contenu du Buffer ...';
  rsCreateTempFile = 'Cration du fichier temporaire ...';
  rsTestTempFile   = 'Test du fichier temporaire ...';
  rsECreatingTemp  = 'Cration du fichier';
  rsETesttingFile  = 'Test du fichier %s';
  rsErreur         = '[Erreur] %s: %s';

const
  BUFMAXSIZE = 512 * 1024;
  MultVitesse : ARRAY [0..6] OF String = ('o/min', 'Ko/min', 'Mo/min', 'Go/min', 'To/min', 'Po/min', 'Eo/min');

type
  TBuffer = array [1..BUFMAXSIZE] of Byte;

var
  Motif: TBuffer;

(*
  Remise  zero du contenue de la fentre.
*)
procedure TTestForm.RAZ;
var
  I: Integer;
begin
  RechNbFich := nil;

  ImageTest1.Picture := nil;
  ImageTest2.Picture := nil;
  ProgressBarRecurse.Position := 0;
  ProgressBarFile.Position := 0;
  ProgressBarCreateTemp.Position := 0;
  ProgressBarVerifTemp.Position := 0;
  LabelStatusFichier.Caption := rsNoneOp;
  LabelStatusFree.Caption := rsNoneOp;
  LabelStatusSize.Caption := EmptyStr;
  LabelStatusFree2.Caption := EmptyStr;
  ListBoxErreur.Items.Clear;

  CumulTailleTest := 0;
  CumulTaille := 0;
  OldTemps := GetTickCount;

  Randomize;
  for I := 1 to BUFMAXSIZE do
    Motif[I] := Random(256);
end;

(*
  Changement de l'icone de validation du fichier
*)
procedure TTestForm.SetValidation(Etape: Integer; const Value: boolean);
begin
  case(Etape) of
    0: ImageListVF.GetBitmap(Integer(Value), ImageTest1.Picture.Bitmap);
    1: ImageListVF.GetBitmap(Integer(Value), ImageTest2.Picture.Bitmap);
  end;
end;

(*
  Cration et Initialisation de la fentre
*)
procedure TTestForm.FormCreate(Sender: TObject);
begin
  RAZ;
end;

procedure TTestForm.VerificationEspaceLibre(const Lecteur: Char);
var TempFiles: TStringList;
    I        : Integer;
begin
  TempFiles := TStringList.Create;
  try
    if(CreateTempFile(Lecteur, TempFiles)) then begin
      if(TestTempFile(TempFiles)) then
        Validation[1] := True
      else
        Validation[1] := False;
    end else
      Validation[1] := False;

  finally
    for I := 0 to TempFiles.Count - 1 do
      DeleteFile(TempFiles[I]);
    TempFiles.free;
  end;
end;

procedure TTestForm.Action2Execute(Sender: TObject);
begin
  RAZ;
  if(DisqueForm.ShowModal = mrOk) then
    VerificationEspaceLibre(UpCase(DisqueForm.ShellComboBox.Path[1]));
end;

function TTestForm.CreateTempFile(const Lecteur: Char; const ListFichier: TStrings): boolean;
var FileName: String;
    TempFile: TFileStream;
    TempFileSize, TempPos: Int64;
    Disque: Byte;
begin
  result := false;

  Disque := Ord(UpCase(Lecteur)) - Ord('A') + 1;
  TempFileSize := DiskFree(Disque);
  TempPos      := 0;

  ProgressBarCreateTemp.Max := Min(MaxInt, TempFileSize);

  LabelStatusFree2.Caption := rsInitBufContent;

  LabelStatusFree2.Caption := rsCreateTempFile;
  TempFile := nil;
  try
    while(DiskFree(Disque) >= BUFMAXSIZE) do begin
      if (not Assigned(TempFile)) or (TempFile.Size >= (Int64(2) * 1024 * 1024 * 1024 - Int64(BUFMAXSIZE))) then begin
        TempFile.Free;

        FileName := GenerateFileName(Lecteur + ':\');
        LabelStatusFree.Caption := Format(rsFileTemp, [FileName]);
        ListFichier.Add(FileName);

        TempFile := TFileStream.Create(FileName, fmCreate);
      end;
      TempFile.WriteBuffer(Motif, BUFMAXSIZE);
      CalculVitesse(BUFMAXSIZE);
      Inc(TempPos, BUFMAXSIZE);

      ProgressBarCreateTemp.Position := Round((TempPos / TempFileSize) * ProgressBarCreateTemp.Max);
      Application.ProcessMessages;
    end;
    result := true;
  except
    on E: Exception do begin
      ListBoxErreur.Items.Add(Format(rsErreur, [rsECreatingTemp, E.Message]));
    end;
  end;
  TempFile.Free;
end;

function TTestForm.TestTempFile(const ListFichier: TStrings): boolean;
var Buff: TBuffer;
    TempFile: TFileStream;
    TempFileSize: Int64;
    I: Integer;
begin
  result := false;
  LabelStatusFree2.Caption := rsTestTempFile;
  TempFile := nil;
  try
    for I := 0 to ListFichier.Count - 1 do begin
      TempFile.Free;
      TempFile := TFileStream.Create(ListFichier[0], fmOpenRead);
      TempFileSize := TempFile.Size;
      ProgressBarVerifTemp.Max := Min(MaxInt, TempFileSize);

      while(TempFile.Position < TempFileSize) do begin
        TempFile.ReadBuffer(Buff, Min(BUFMAXSIZE, TempFileSize - TempFile.Position));
        if not CompareMem(@Buff, @Motif, BUFMAXSIZE) then
          raise EReadError.Create('Motif diffrents');
        CalculVitesse(BUFMAXSIZE);

        ProgressBarVerifTemp.Position := Round((TempFile.Position / TempFileSize) * ProgressBarCreateTemp.Max);
        Application.ProcessMessages;
      end;
    end;
    result := true;
  except
    on E: Exception do begin
      ListBoxErreur.Items.Add(Format(rsErreur, [Format(rsETesttingFile, [ListFichier[0]]), E.Message]));
    end;
  end;
  TempFile.Free;
end;

procedure TTestForm.CalculVitesse(const NombreOctet: Int64);
var Vitesse: Int64;
begin
  Inc(CumulTaille, NombreOctet);
  if(OldTemps < GetTickCount - 5000) then begin
    Vitesse := Round(1000 * CumulTaille / (GetTickCount - OldTemps)) * 60;
    CumulTaille := 0;
    OldTemps := GetTickCount;

    StatusBar.Panels[1].Text := SizeToStr(Vitesse, MultVitesse);
  end;
end;

function TTestForm.TestFile(const FileName: string): boolean;
var Buff: TBuffer;
    FileSt: TFileStream;
    FileSize: Int64;
begin
  result := false;
  FileSt := nil;
  try
    FileSt := TFileStream.Create(FileName, fmOpenRead);
    FileSize := FileSt.Size;
    ProgressBarFile.Max := Min(MaxInt, FileSize);

    while(FileSt.Position < FileSize) do begin
      FileSt.ReadBuffer(Buff, Min(BUFMAXSIZE, FileSize - FileSt.Position));
      CalculVitesse(BUFMAXSIZE);

      ProgressBarFile.Position := Round((FileSt.Position / FileSize) * ProgressBarFile.Max);
      LabelStatusSize.Caption := Format(rsTailleFichiers, [SizeToStr(CumulTailleTest), SizeToStr(FileSt.Position)]);
      Application.ProcessMessages;
    end;

    Inc(CumulTailleTest, FileSt.Position);
    result := true;
  except
    on E: Exception do begin
      ListBoxErreur.Items.Add(Format(rsErreur, [Format(rsETesttingFile, [FileName]), E.Message]));
    end;
  end;
  FileSt.Free;
end;

function TTestForm.RechercheFile(const Dossier: string): boolean;
var res : integer;
    SRec: TSearchRec;
    Chaine: string;
begin
  result := true;

  res := FindFirst(NormalDir(Dossier) + '*.*', faAnyFile, SRec);
  while(res = 0) do begin
    if(faDirectory and SRec.Attr > 0) then begin
      if((SRec.Name <> '.') and (SRec.Name <> '..')) then
        result := RechercheFile(NormalDir(Dossier) + SRec.Name) and result;
    end else begin
      Chaine := Format(rsDossier, [Dossier]);
      LabelStatusFichier.Caption := MinimizeFileName(Chaine,
        Round(
          (LabelStatusFichier.Width * Length(Chaine)) / Canvas.TextWidth(Chaine)
        )
      );
      result := TestFile(NormalDir(Dossier) + SRec.Name) and result;
      ProgressBarRecurse.Max := RechNbFich.NombreFichier;
      ProgressBarRecurse.Position := ProgressBarRecurse.Position + 1;
    end;
    res := FindNext(SRec);
  end;
  FindClose(SRec);
end;

procedure TTestForm.Action1Execute(Sender: TObject);
begin
  RAZ;
  if(DossierForm.ShowModal = mrOk) then
    TestFiles(DossierForm.ShellTreeView.Path);
end;

function TTestForm.TestFiles(const Dossier: string): boolean;
begin
  RechNbFich := TNombreFichier.Create(Dossier);
  try
    result := RechercheFile(Dossier);
    Validation[0] := result;
  finally
    RechNbFich.Free;
  end;
end;

procedure TTestForm.Action3Execute(Sender: TObject);
begin
  RAZ;
  if(DisqueForm.ShowModal = mrOk) then begin
    TestFiles(DisqueForm.ShellComboBox.Path);
    VerificationEspaceLibre(UpCase(DisqueForm.ShellComboBox.Path[1]));
  end;
end;

end.
